#ifndef NodeManager_h
#define NodeManager_h

class Stepnode;
#include "AccelStepnode.h"

#define MAX_NODES 4

class NodeManager {
public:
    NodeManager(HardwareSerial* serial, uint8_t n_nodes);
    ~NodeManager();
    void init();
    void setEnabled(uint8_t i, bool active);
    bool getEnabled(uint8_t i);
    bool getEndstop(uint8_t i);
    void setMaxSpeed(uint8_t i, float speed);
    void setAcceleration(uint8_t i, float acc);
    void setCurrentPosition(uint8_t i, long pos);
    long getCurrentPosition(uint8_t i);
    void setTarget(uint8_t i, long pos);
    void runToTarget();
    bool run();
    bool homing(uint8_t i, long pos_max, long pos_new, float speed);
    char send;
    char recv;
private:
    void flush_input();
    void sync_send();
    bool sync_both();
    HardwareSerial* _serial;
    uint8_t _n;
    Stepnode* _nodes;
};

#endif
